Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderReactRedux = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _reactRedux = require('react-redux');

var _hypernova = require('hypernova');

var _hypernova2 = _interopRequireDefault(_hypernova);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function buildProvider(connectedComponent, store) {
  return _react2['default'].createElement(
    _reactRedux.Provider,
    { store: store },
    _react2['default'].isValidElement(connectedComponent) ? connectedComponent : _react2['default'].createElement(connectedComponent)
  );
}

var renderReactRedux = exports.renderReactRedux = function renderReactRedux(name, connectedComponent, configureStore) {
  return (0, _hypernova2['default'])({
    server: function () {
      function server() {
        return function (props) {
          var provider = buildProvider(connectedComponent, configureStore(props));
          var contents = _server2['default'].renderToString(provider);
          return (0, _hypernova.serialize)(name, contents, props);
        };
      }

      return server;
    }(),
    client: function () {
      function client() {
        var _load = (0, _hypernova.load)(name);

        var node = _load.node;
        var data = _load.data;


        if (node) {
          var provider = buildProvider(connectedComponent, configureStore(data));
          _reactDom2['default'].render(provider, node);
        }

        return connectedComponent;
      }

      return client;
    }()
  });
};